using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;

namespace RSASecurityTools
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        public byte[] mymsg;

        public byte[] Encrypt(string strData, CspParameters PrivateKey)
        {
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider(PrivateKey);
            byte[] data = rsa.Encrypt(Encoding.Unicode.GetBytes(strData), false);
            return data;
        }

        public byte[] Decrypt(byte[] en_data, CspParameters PrivateKey)
        {
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider(PrivateKey);
            byte[] data = rsa.Decrypt(en_data, false);
            return data;
        }

        public void add_user(string username, string password)
        {
            try
            {
                CspParameters cp = new CspParameters();
                cp.KeyContainerName = password;
                byte[] encrypted_password = Encrypt(password, cp);

                SqlConnection con = new SqlConnection(Properties.Settings.Default.MyDatabaseConnectionString);
                con.Open();
                SqlCommand insert = new SqlCommand("INSERT INTO Table1(UserName,User_Password) VALUES (@UserName, @User_Password)", con);
                insert.Parameters.Add(new SqlParameter("@UserName", SqlDbType.VarChar)).Value = username;
                insert.Parameters.Add(new SqlParameter("@User_Password", SqlDbType.Binary)).Value = encrypted_password;
                insert.ExecuteNonQuery();
                con.Close();
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }
        }

        public byte[] Read_Pass_Record(string UserName)
        {
            byte[] array = null;
            try
            {
                string com = "SELECT User_Password FROM Table1 WHERE UserName='" + UserName + "'";
                DataSet ds = new DataSet();
                SqlDataAdapter sql = new SqlDataAdapter(com, Properties.Settings.Default.MyDatabaseConnectionString);
                sql.Fill(ds);
                array = (((byte[])(ds.Tables[0].Rows[0][0])));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            return array;
        }


        public bool Validate_User(string username, string password)
        {
            bool state = false;
            try
            {
                CspParameters cp = new CspParameters();
                cp.KeyContainerName = password;

                byte[] encryptedArr = Read_Pass_Record(username);
                byte[] decryptedArr = Decrypt(encryptedArr, cp);
                state = true;

            }
            catch (Exception) {state = false; }

            return state;
        }
	
        private void button3_Click(object sender, EventArgs e)
        {
            add_user(_UserName.Text, _Password.Text);		
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (Validate_User(User_Name.Text, Pass_word.Text))
            {
                MessageBox.Show("Authorized");
            }
            else MessageBox.Show("Wrong");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            text_decrypted.Clear();
            try
            {
                CspParameters cp = new CspParameters();
                cp.KeyContainerName = text_private1.Text;

                FileStream fs = new FileStream(@"C:\mydata.dat", FileMode.Open);
                BinaryFormatter br = new BinaryFormatter();

                RSAData rsa = (RSAData)br.Deserialize(fs);

                byte[] my_msg = Decrypt(rsa.buffer, cp);
                text_decrypted.Text = Encoding.Unicode.GetString(my_msg);
            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                CspParameters cp = new CspParameters();
                cp.KeyContainerName = text_private.Text;

                mymsg = Encrypt(text_msg_to_send.Text, cp);

                FileStream fs = new FileStream(@"C:\mydata.dat", FileMode.Create);

                BinaryFormatter br = new BinaryFormatter();

                RSAData rs = new RSAData(mymsg);

                br.Serialize(fs, rs);
                fs.Close();

                text_encrypted.Text = Encoding.Unicode.GetString(mymsg);

            }
            catch (Exception ex) { MessageBox.Show(ex.Message); }

        }
    }
}